package com.anbo.geocoderexample;

import android.app.Activity;
import android.app.Application;
import android.location.Address;
import android.location.Geocoder;
import android.os.Bundle;
import android.widget.TextView;

import java.io.IOException;
import java.util.List;

public class MainActivity extends Activity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        Application application = getApplication();
        Geocoder geocoder = new Geocoder(application);
        int maxResults = 4;

        // Geocoding: location name -> (latitude, longitude)
        String locationName = "Elisagårdsvej, 4000 Roskilde, Denmark";
        TextView view2 = (TextView) findViewById(R.id.main_position_textview);
        view2.setText(locationName + "\n");
        try {
            List<Address> addressList = geocoder.getFromLocationName(locationName, maxResults);
            for (Address addr : addressList) {
                view2.append(addr.getLatitude() + ": " + addr.getLongitude());
            }
        } catch (IOException e) {
            view2.setText(e.getMessage());
        }

        // Reverse geocoding: (latitude, longitude) -> address(es)
        double latitude = 55.642843;
        double longitude = 12.1014303;
        TextView view1 = (TextView) findViewById(R.id.main_addresses_textview);
        view1.setText("Lat: " + latitude + " Long:" + longitude + "\n");
        try {

            List<Address> addressList = geocoder.getFromLocation(latitude, longitude, maxResults);
            for (Address addr : addressList) {
                StringBuilder sb = new StringBuilder();
                for (int i = 0; i < addr.getMaxAddressLineIndex(); i++) {
                    sb.append(addr.getAddressLine(i));
                    sb.append(", ");
                }
                view1.append(sb + "\n");
            }
            // view.setText(addressList.toString());
        } catch (IOException e) {
            view1.setText(e.getMessage());
        }
    }
}
